profunctors-5.2.1: Profunctors

Safe Haskell | Safe
Language | Haskell2010

Data.Profunctor.Mapping

Contents

- Closed in terms of Mapping

Synopsis

- class (Traversing p, Closed p) => Mapping p where
- newtype CofreeMapping p a b = CofreeMapping {
  - runCofreeMapping :: forall f. Functor f => p (f a) (f b)
  }
- data FreeMapping p a b where
  - FreeMapping :: Functor f => (f y -> b) -> p x y -> (a -> f x) -> FreeMapping p a b
- traverseMapping :: (Mapping p, Functor f) => p a b -> p (f a) (f b)
- closedMapping :: Mapping p => p a b -> p (x -> a) (x -> b)

# Documentation

class (Traversing p, Closed p) => Mapping p where Source #

Minimal complete definition

map'

Methods

map' :: Functor f => p a b -> p (f a) (f b) Source #

Laws:

    map' . rmap f ≡ rmap (fmap f) . map'
    map' . map' ≡ dimap Compose getCompose . map'
    dimap Identity runIdentity . map' ≡ id

Instances

Mapping (->) Source # |
Methods map' :: Functor f => (a -> b) -> f a -> f b Source #
(Monad m, Distributive m) => Mapping (Kleisli m) Source # |
Methods map' :: Functor f => Kleisli m a b -> Kleisli m (f a) (f b) Source #
(Applicative m, Distributive m) => Mapping (Star m) Source # |
Methods map' :: Functor f => Star m a b -> Star m (f a) (f b) Source #
Mapping (FreeMapping p) Source # |
Methods map' :: Functor f => FreeMapping p a b -> FreeMapping p (f a) (f b) Source #
Profunctor p => Mapping (CofreeMapping p) Source # |
Methods map' :: Functor f => CofreeMapping p a b -> CofreeMapping p (f a) (f b) Source #
Mapping p => Mapping (Coyoneda p) Source # |
Methods map' :: Functor f => Coyoneda p a b -> Coyoneda p (f a) (f b) Source #
Mapping p => Mapping (Yoneda p) Source # |
Methods map' :: Functor f => Yoneda p a b -> Yoneda p (f a) (f b) Source #
(Mapping p, Mapping q) => Mapping (Procompose p q) Source # |
Methods map' :: Functor f => Procompose p q a b -> Procompose p q (f a) (f b) Source #

newtype CofreeMapping p a b Source #

Constructors

CofreeMapping |

Fields

- runCofreeMapping :: forall f. Functor f => p (f a) (f b)

Instances

ProfunctorComonad CofreeMapping Source # |
Methods proextract :: Profunctor p => CofreeMapping p :-> p Source # produplicate :: Profunctor p => CofreeMapping p :-> CofreeMapping (CofreeMapping p) Source #
ProfunctorFunctor CofreeMapping Source # |
Methods promap :: Profunctor p => (p :-> q) -> CofreeMapping p :-> CofreeMapping q Source #
Profunctor p => Profunctor (CofreeMapping p) Source # |

Methods

dimap :: (a -> b) -> (c -> d) -> CofreeMapping p b c -> CofreeMapping p a d Source #

lmap :: (a -> b) -> CofreeMapping p b c -> CofreeMapping p a c Source #

rmap :: (b -> c) -> CofreeMapping p a b -> CofreeMapping p a c Source #

(#.) :: Coercible * c b => (b -> c) -> CofreeMapping p a b -> CofreeMapping p a c Source #

(.#) :: Coercible * b a => CofreeMapping p b c -> (a -> b) -> CofreeMapping p a c Source #

Profunctor p => Strong (CofreeMapping p) Source # |
Methods first' :: CofreeMapping p a b -> CofreeMapping p (a, c) (b, c) Source # second' :: CofreeMapping p a b -> CofreeMapping p (c, a) (c, b) Source #
Profunctor p => Choice (CofreeMapping p) Source # |
Methods left' :: CofreeMapping p a b -> CofreeMapping p (Either a c) (Either b c) Source # right' :: CofreeMapping p a b -> CofreeMapping p (Either c a) (Either c b) Source #
Profunctor p => Closed (CofreeMapping p) Source # |
Methods closed :: CofreeMapping p a b -> CofreeMapping p (x -> a) (x -> b) Source #
Profunctor p => Traversing (CofreeMapping p) Source # |
Methods traverse' :: Traversable f => CofreeMapping p a b -> CofreeMapping p (f a) (f b) Source # wander :: (forall f. Applicative f => (a -> f b) -> s -> f t) -> CofreeMapping p a b -> CofreeMapping p s t Source #
Profunctor p => Mapping (CofreeMapping p) Source # |
Methods map' :: Functor f => CofreeMapping p a b -> CofreeMapping p (f a) (f b) Source #

data FreeMapping p a b where Source #

    FreeMapping -| CofreeMapping

Constructors

FreeMapping :: Functor f => (f y -> b) -> p x y -> (a -> f x) -> FreeMapping p a b |

Instances

ProfunctorMonad FreeMapping Source # |
Methods proreturn :: Profunctor p => p :-> FreeMapping p Source # projoin :: Profunctor p => FreeMapping (FreeMapping p) :-> FreeMapping p Source #
ProfunctorFunctor FreeMapping Source # |
Methods promap :: Profunctor p => (p :-> q) -> FreeMapping p :-> FreeMapping q Source #
Profunctor (FreeMapping p) Source # |
Methods dimap :: (a -> b) -> (c -> d) -> FreeMapping p b c -> FreeMapping p a d Source # lmap :: (a -> b) -> FreeMapping p b c -> FreeMapping p a c Source # rmap :: (b -> c) -> FreeMapping p a b -> FreeMapping p a c Source # (#.) :: Coercible * c b => (b -> c) -> FreeMapping p a b -> FreeMapping p a c Source # (.#) :: Coercible * b a => FreeMapping p b c -> (a -> b) -> FreeMapping p a c Source #
Strong (FreeMapping p) Source # |
Methods first' :: FreeMapping p a b -> FreeMapping p (a, c) (b, c) Source # second' :: FreeMapping p a b -> FreeMapping p (c, a) (c, b) Source #
Choice (FreeMapping p) Source # |
Methods left' :: FreeMapping p a b -> FreeMapping p (Either a c) (Either b c) Source # right' :: FreeMapping p a b -> FreeMapping p (Either c a) (Either c b) Source #
Closed (FreeMapping p) Source # |
Methods closed :: FreeMapping p a b -> FreeMapping p (x -> a) (x -> b) Source #
Traversing (FreeMapping p) Source # |
Methods traverse' :: Traversable f => FreeMapping p a b -> FreeMapping p (f a) (f b) Source # wander :: (forall f. Applicative f => (a -> f b) -> s -> f t) -> FreeMapping p a b -> FreeMapping p s t Source #
Mapping (FreeMapping p) Source # |
Methods map' :: Functor f => FreeMapping p a b -> FreeMapping p (f a) (f b) Source #

# Closed in terms of Mapping

traverseMapping :: (Mapping p, Functor f) => p a b -> p (f a) (f b) Source #

closedMapping :: Mapping p => p a b -> p (x -> a) (x -> b) Source #